from typing import Any, Dict, List

from pydantic import BaseModel


class ImmediateLive(BaseModel):
    duration: int
    createThreshold: int


class IceServer(BaseModel):
    url: str
    username: str
    credential: str


class Config(BaseModel):
    sidebar: int | None
    blipName: str | None
    newClock: bool | None
    slateBreak: Dict[str, Any] | None
    immediateLive: ImmediateLive | None
    unmanagedMode: str | None
    elasticCacheEndpoint: str | None
    iceTransportPolicy: str | None
    iceServers: List[IceServer]


class Plec(BaseModel):
    mode: str | None
    debug: bool | None
    config: Config
    version: str


class Nexus(BaseModel):
    plec: Plec


class CRDConfig(BaseModel):
    nexus: Nexus
