import yaml

from pathlib import Path
from typing import Literal
from ruamel.yaml import YAML

YamlParser = Literal['ruamel', 'pyyaml']


def read_yaml(path: Path, parser: YamlParser = 'pyyaml'):
    with open(path, 'r') as file:
        if parser == 'pyyaml':
            data = yaml.safe_load(file)
        elif parser == 'ruamel':
            yaml_ = YAML()
            data = yaml_.load(file)
        else:
            raise NotImplementedError('yaml parser not implemented')
    return data


def load_yaml(data: str, parser: YamlParser):
    if parser == 'pyyaml':
        loaded = yaml.safe_load(data)
    elif parser == 'ruamel':
        yaml_ = YAML()
        loaded = yaml_.load(data)
    else:
        raise NotImplementedError('yaml parser not implemented')
    return loaded


def write_md(path: Path, content: str):
    with open(path, 'w') as f:
        f.write(content)
